SystemOrganization addCategory: #ConfigurationOfXtreams!

Object subclass: #ConfigurationOfXtreams
	instanceVariableNames: 'project originalUnderscoreSelectorsPreferenceValue'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfXtreams'!

!ConfigurationOfXtreams commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfXtreams class methodsFor: 'development support' stamp: 'ul 2/21/2011 04:29'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'ul 2/21/2011 04:29'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'ul 2/21/2011 04:29'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'ul 2/21/2011 04:29'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfXtreams class methodsFor: 'metacello tool support' stamp: 'ul 2/21/2011 04:29'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfXtreams class methodsFor: 'accessing' stamp: 'ul 2/21/2011 04:29'!
project

	^self new project! !

!ConfigurationOfXtreams class methodsFor: 'development support' stamp: 'ul 2/21/2011 04:29'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfXtreams methodsFor: 'baselines' stamp: 'ul 2/21/2011 05:14'!
baseline100: spec 
	<version: '1.0-baseline'>
        
	spec for: #common do: [
                spec blessing: #baseline ].

	spec for: #squeakCommon do: [
		spec repository: 'http://www.squeaksource.com/Xtreams'.
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Xtreams-Support';
			package: 'Xtreams-Core';
			package: 'Xtreams-Terminals';
			package: 'Xtreams-Transforms';
			package: 'Xtreams-Substreams';
			package: 'Xtreams-Parsing';
			" --- tests follow --- "
			package: 'Xtreams-CoreTests' with: [ spec requires: 'Xtreams-Core' ];
			package: 'Xtreams-TerminalsTests' with: [ spec requires: 'Xtreams-Terminals' ];
			package: 'Xtreams-TransformsTests' with: [ spec requires: 'Xtreams-Transforms' ];
			package: 'Xtreams-SubstreamsTests' with: [ spec requires: 'Xtreams-Substreams' ];
			package: 'Xtreams-ParsingTests' with: [ spec requires: 'Xtreams-Parsing' ];
			" --- following require FFI --- "
			package: 'Xtreams-Xtras' with: [
				spec 
					requires: #('FFI') ];
			package: 'Xtreams-XtrasTests' with: [ spec requires: 'Xtreams-Xtras' ].
		spec
			group: 'default' with: #('Full Tests');
			group: 'Core' with: #(
				'Xtreams-Support'
				'Xtreams-Core'
				'Xtreams-Terminals'
				'Xtreams-Transforms'
				'Xtreams-Substreams'
				'Xtreams-Parsing');
			group: 'Tests' with: #(
				'Xtreams-CoreTests'
				'Xtreams-TerminalsTests'
				'Xtreams-TransformsTests'
				'Xtreams-SubstreamsTests'
				'Xtreams-ParsingTests');
			group: 'Full' with: #('Core' 'Xtreams-Xtras');
			group: 'Full Tests' with: #('Full' 'Tests' 'Xtreams-XtrasTests') ].
		
	spec for: #squeak do: [
		spec package: 'Xtreams-Xtras' with: [
			spec 
				requires: #('FFI');
				preLoadDoIt: #preLoadSqueakEnsureGlobalUnderscoreSelectors;
				postLoadDoIt: #postLoadSqueakRestoreGlobalUnderscoreSelectors ] ]! !

!ConfigurationOfXtreams methodsFor: 'doits' stamp: 'ul 2/21/2011 04:59'!
postLoadSqueakRestoreGlobalUnderscoreSelectors 

	Scanner prefAllowUnderscoreSelectors: originalUnderscoreSelectorsPreferenceValue! !

!ConfigurationOfXtreams methodsFor: 'doits' stamp: 'ul 2/21/2011 05:08'!
preLoadSqueakEnsureGlobalUnderscoreSelectors

	originalUnderscoreSelectorsPreferenceValue := Scanner prefAllowUnderscoreSelectors.
	Scanner prefAllowUnderscoreSelectors: true.
	$_ tokenish ifFalse: [
		Character
			compile: 'tokenish
		"Answer whether the receiver is a valid token-character--letter, digit, or
		colon."

		^self == $_ or: [self == $: or: [self isLetter or: [self isDigit]]]'
			classified: 'testing'.
		String initialize ].! !

!ConfigurationOfXtreams methodsFor: 'accessing' stamp: 'ul 2/21/2011 04:29'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
